<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/core/Logger.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_3d69f64eaf81436fe2b22361382717e5.html">core</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">Logger.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="Logger_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &quot;spdlog/fmt/ostr.h&quot;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &quot;spdlog/spdlog.h&quot;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span>{</div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno"><a class="line" href="classgg_1_1Logger.html">    9</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1Logger.html">Logger</a></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>{</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno"><a class="line" href="classgg_1_1Logger.html#a09108b93348b8640d9e9d4ba62e91b1d">   12</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Logger.html#a09108b93348b8640d9e9d4ba62e91b1d">Init</a>();</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="classgg_1_1Logger.html#a1223629c433581dc197046a024eefe10">   14</a></span>    <span class="keyword">static</span> std::shared_ptr&lt;spdlog::logger&gt; &amp;<a class="code hl_function" href="classgg_1_1Logger.html#a1223629c433581dc197046a024eefe10">GetCoreLogger</a>()</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>    {</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>        <span class="keywordflow">return</span> s_coreLogger;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>    };</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="classgg_1_1Logger.html#ae1577a0a5f650e2eb2c728cc0f13e9f4">   18</a></span>    <span class="keyword">static</span> std::shared_ptr&lt;spdlog::logger&gt; &amp;<a class="code hl_function" href="classgg_1_1Logger.html#ae1577a0a5f650e2eb2c728cc0f13e9f4">GetDebugLogger</a>()</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>    {</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>        <span class="keywordflow">return</span> s_debugLogger;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    };</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    <span class="keyword">static</span> std::shared_ptr&lt;spdlog::logger&gt; s_coreLogger;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>    <span class="keyword">static</span> std::shared_ptr&lt;spdlog::logger&gt; s_debugLogger;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>};</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a42b67fc79f6fccf7995858bc6880984f">   28</a></span><span class="preprocessor">#define GG_BREAK __builtin_trap(); </span><span class="comment">// TODO: Make this platform specific</span></div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a8436c5a56a3465fe6734453e1dff87fb">   30</a></span><span class="preprocessor">#define GG_TRACE(...) ::gg::Logger::GetCoreLogger()-&gt;trace(__VA_ARGS__)</span></div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a5735309bc12e817923d9bc2a28d95cf5">   31</a></span><span class="preprocessor">#define GG_INFO(...) ::gg::Logger::GetCoreLogger()-&gt;info(__VA_ARGS__)</span></div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a89f0a1b7c5799f73e211da567b175ca0">   32</a></span><span class="preprocessor">#define GG_ERROR(...) ::gg::Logger::GetCoreLogger()-&gt;error(__VA_ARGS__)</span></div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a00e30644eae60ba35ab8a796266faeff">   33</a></span><span class="preprocessor">#define GG_WARN(...) ::gg::Logger::GetCoreLogger()-&gt;warn(__VA_ARGS__)</span></div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a9c80a590bd4111b473a95e9fe05d7bb7">   34</a></span><span class="preprocessor">#define GG_CRITICAL(...) ::gg::Logger::GetCoreLogger()-&gt;critical(__VA_ARGS__)</span></div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a8b9062fa5185a35273ca114930d28250">   36</a></span><span class="preprocessor">#define GG_ASSERT(x, msg)                                                      \</span></div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span><span class="preprocessor">    if ((x)) {                                                                 \</span></div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span><span class="preprocessor">    } else {                                                                   \</span></div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span><span class="preprocessor">        GG_CRITICAL(                                                           \</span></div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span><span class="preprocessor">            &quot;Asset: {}\n\tMessage: {}\n\tFile: {}: {}&quot;</span>,                        \</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>            #x,                                                                \</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>            msg,                                                               \</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>            __FILE__,                                                          \</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>            __LINE__);                                                         \</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        exit(EXIT_FAILURE);                                                    \</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>    }</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span><span class="preprocessor">#ifdef GG_DEBUG</span></div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span> </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span><span class="preprocessor">#define GG_DEBUG_TRACE(...) ::gg::Logger::GetDebugLogger()-&gt;trace(__VA_ARGS__)</span></div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span><span class="preprocessor">#define GG_DEBUG_INFO(...) ::gg::Logger::GetDebugLogger()-&gt;info(__VA_ARGS__)</span></div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span><span class="preprocessor">#define GG_DEBUG_ERROR(...) ::gg::Logger::GetDebugLogger()-&gt;error(__VA_ARGS__)</span></div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="preprocessor">#define GG_DEBUG_WARN(...) ::gg::Logger::GetDebugLogger()-&gt;warn(__VA_ARGS__)</span></div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span><span class="preprocessor">#define GG_DEBUG_CRITICAL(...)                                                 \</span></div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span><span class="preprocessor">    ::gg::Logger::GetDebugLogger()-&gt;critical(__VA_ARGS__)</span></div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span><span class="preprocessor">#define GG_DEBUG_ASSERT(x, msg)                                                \</span></div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span><span class="preprocessor">    if ((x)) {                                                                 \</span></div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span><span class="preprocessor">    } else {                                                                   \</span></div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span><span class="preprocessor">        GG_DEBUG_CRITICAL(                                                     \</span></div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span><span class="preprocessor">            &quot;Asset: {}\n\tMessage: {}\n\tFile: {}: {}&quot;</span>,                        \</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>            #x,                                                                \</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>            msg,                                                               \</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>            __FILE__,                                                          \</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>            __LINE__);                                                         \</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        GG_BREAK;                                                              \</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    }</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a84eaacb33b7342cd388ad3f5287335ec">   71</a></span><span class="preprocessor">#define GG_DEBUG_TRACE(...)</span></div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a008ad2efa29e991cf27dd5651e81944c">   72</a></span><span class="preprocessor">#define GG_DEBUG_INFO(...)</span></div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a2b63b317319efca9632c89d2555512b8">   73</a></span><span class="preprocessor">#define GG_DEBUG_ERROR(...)</span></div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a918130d1983e4c0692eb011aa3403ddf">   74</a></span><span class="preprocessor">#define GG_DEBUG_WARN(...)</span></div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a9b807d91b837a06514d8df28d2a7715d">   75</a></span><span class="preprocessor">#define GG_DEBUG_CRITICAL(...)</span></div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno"><a class="line" href="Logger_8hpp.html#a52d8bf3071e65034fbd905dbb53b3e5b">   77</a></span><span class="preprocessor">#define GG_DEBUG_ASSERT(x, msg)</span></div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span><span class="preprocessor">#endif </span><span class="comment">// GG_DEBUG</span></div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span> </div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aclassgg_1_1Logger_html"><div class="ttname"><a href="classgg_1_1Logger.html">gg::Logger</a></div><div class="ttdef"><b>Definition:</b> Logger.hpp:10</div></div>
<div class="ttc" id="aclassgg_1_1Logger_html_a09108b93348b8640d9e9d4ba62e91b1d"><div class="ttname"><a href="classgg_1_1Logger.html#a09108b93348b8640d9e9d4ba62e91b1d">gg::Logger::Init</a></div><div class="ttdeci">static void Init()</div></div>
<div class="ttc" id="aclassgg_1_1Logger_html_a1223629c433581dc197046a024eefe10"><div class="ttname"><a href="classgg_1_1Logger.html#a1223629c433581dc197046a024eefe10">gg::Logger::GetCoreLogger</a></div><div class="ttdeci">static std::shared_ptr&lt; spdlog::logger &gt; &amp; GetCoreLogger()</div><div class="ttdef"><b>Definition:</b> Logger.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1Logger_html_ae1577a0a5f650e2eb2c728cc0f13e9f4"><div class="ttname"><a href="classgg_1_1Logger.html#ae1577a0a5f650e2eb2c728cc0f13e9f4">gg::Logger::GetDebugLogger</a></div><div class="ttdeci">static std::shared_ptr&lt; spdlog::logger &gt; &amp; GetDebugLogger()</div><div class="ttdef"><b>Definition:</b> Logger.hpp:18</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
